#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <math.h>
#include <omp.h>

#include "FreqSetter.h"
#include "probe_msr.h"

unsigned int entryPoint2 (unsigned int n, double* tab1, double* tab2)
{
    unsigned int i;
    double *a;
    double *b;
    
	int tid = omp_get_thread_num();
   a = &(tab1[tid*n*4]);
   b = &(tab2[tid*n*4]);

   for (i=0; i < n; i ++)
   {
      b[(16*i+(i&1))*8] = a[(16*i+(i&1))*8];
   }

   return (n-1);
}

void test(unsigned int nMEM, 
			 double* tab1, double* tab2,
			 unsigned int iterations)
{
   unsigned int iteration;

	for ( iteration = 0; iteration < iterations; iteration ++)
	{
		#pragma omp parallel default(none) firstprivate(tab1,tab2) shared(nMEM)
		{
			int nThreads = omp_get_num_threads() ;
			unsigned int size = nMEM/nThreads;
			entryPoint2(size, tab1, tab2);
		}
	}
}


